## google-compute-engine-20170829-20170829.tar.gz

=== google_compute_engine_oslogin/Makefile ===
SHELL = /bin/sh

BASENAME = oslogin
NAME = google-compute-engine-$(BASENAME)
MAJOR = 1
MINOR = 0
REVISION = 3

NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2
NSS_INSTALL_PATH = /lib
PAM_INSTALL_PATH = /lib/security
AUTHKEYS_INSTALL_PATH = /usr/bin

CXX = g++
CXXFLAGS += -fPIC# -Wall
PAMFLAGS = $(LDFLAGS) -shared
NSSFLAGS = $(LDFLAGS) -shared -Wl,-soname,$(NSS_LIBRARY_SONAME)

# UTILS
UTILS_DIR = utils
UTILS_SRC = $(UTILS_DIR)/$(BASENAME)_utils.cc
UTILS = $(UTILS_DIR)/$(BASENAME)_utils.o

# AUTHORIZED KEYS
AUTHKEYS_DIR = authorized_keys
AUTHKEYS_SRC = $(AUTHKEYS_DIR)/authorized_keys.cc
AUTHKEYS_BIN = google_authorized_keys

# NSS
NSS = nss_$(BASENAME)
NSS_DIR = nss_module
NSS_SRC = $(NSS_DIR)/$(NSS).cc

# PAM
PAM = pam_$(BASENAME)
PAM_DIR = pam_module
PAM_ADMIN = $(PAM)_admin
PAM_ADMIN_SRC = $(PAM_DIR)/$(PAM_ADMIN).cc
PAM_ADMIN_OBJ = $(PAM_DIR)/$(PAM_ADMIN).o
PAM_ADMIN_MOD = $(PAM_ADMIN).so
PAM_LOGIN = $(PAM)_login
PAM_LOGIN_SRC = $(PAM_DIR)/$(PAM_LOGIN).cc
PAM_LOGIN_OBJ = $(PAM_DIR)/$(PAM_LOGIN).o
PAM_LOGIN_MOD = $(PAM_LOGIN).so

# HELPER SCRIPTS
BIN_DIR = bin
OSLOGIN_HELPER = $(BIN_DIR)/google_oslogin_control
BIN_INSTALL_PATH = /usr/bin

# SELINUX POLICY
INSTALL_SELINUX =
POLICY_DIR = policy
SELINUX_MODULE_SRC = $(POLICY_DIR)/oslogin$(DIST).te
SELINUX_MOD_FILE = $(POLICY_DIR)/oslogin$(DIST).mod
SELINUX_MODULE = $(POLICY_DIR)/oslogin$(DIST).pp
SELINUX_INSTALL_NAME = oslogin.pp
SELINUX_INSTALL_PATH = /usr/share/selinux/packages

LIBS = -lcurl -ljson-c
PAM_LIBS = -lpam $(LIBS)

ifdef INSTALL_SELINUX
all: $(NSS) $(PAM) $(AUTHKEYS_BIN) $(SELINUX_MODULE)
else
all: $(NSS) $(PAM) $(AUTHKEYS_BIN)
endif

$(NSS): $(NSS_LIBRARY_SOURCE) $(UTILS)
	$(CXX) $(CXXFLAGS) $(NSSFLAGS) -o $(NSS_LIBRARY_NAME) \
	$(NSS_SRC) $(UTILS) $(LIBS)

$(PAM): $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD)

$(PAM_LOGIN_MOD): $(PAM_LOGIN_OBJ) $(UTILS)
	$(CXX) $(PAMFLAGS) -o $(PAM_LOGIN_MOD) $(PAM_LOGIN_OBJ) $(UTILS) $(PAM_LIBS)

$(PAM_ADMIN_MOD): $(PAM_ADMIN_OBJ) $(UTILS)
	$(CXX) $(PAMFLAGS) -o $(PAM_ADMIN_MOD) $(PAM_ADMIN_OBJ) $(UTILS) $(PAM_LIBS)

$(PAM_LOGIN_OBJ): $(PAM_LOGIN_SRC)
	$(CXX) $(CXXFLAGS) -c $(PAM_LOGIN_SRC) -o $(PAM_LOGIN_OBJ)

$(PAM_ADMIN_OBJ): $(PAM_ADMIN_SRC)
	$(CXX) $(CXXFLAGS) -c $(PAM_ADMIN_SRC) -o $(PAM_ADMIN_OBJ)

$(AUTHKEYS_BIN): $(AUTHKEYS_SRC) $(UTILS_SRC)
	$(CXX) $(LDFLAGS) -o $(AUTHKEYS_BIN) $(AUTHKEYS_SRC) $(UTILS_SRC) $(LIBS)

$(UTILS): $(UTILS_SRC)
	$(CXX) $(CXXFLAGS) -c $(UTILS_SRC) -o $(UTILS)

$(SELINUX_MOD_FILE): $(SELINUX_MODULE_SRC)
	checkmodule -M -m -o $(SELINUX_MOD_FILE) $(SELINUX_MODULE_SRC)

$(SELINUX_MODULE): $(SELINUX_MOD_FILE)
	semodule_package -o $(SELINUX_MODULE) -m  $(SELINUX_MOD_FILE)


ifdef INSTALL_SELINUX
install: $(NSS_LIBRARY_NAME) $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN) $(SELINUX_MODULE)
else
install: $(NSS_LIBRARY_NAME) $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN)
endif
	mkdir -p $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
	install -m 0644 $(NSS_LIBRARY_NAME) $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
	install -m 0644 $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)
	install -m 0755 $(AUTHKEYS_BIN) $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)
	install -m 0755 $(OSLOGIN_HELPER) $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
ifdef INSTALL_SELINUX
	mkdir -p $(DESTDIR)$(PREFIX)/$(SELINUX_INSTALL_PATH)
	install -T -m 0644 $(SELINUX_MODULE) $(DESTDIR)$(PREFIX)/$(SELINUX_INSTALL_PATH)/$(SELINUX_INSTALL_NAME)
endif

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)/$(NSS_LIBRARY_NAME)
	rm -f $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)/$(PAM_ADMIN_MOD)
	rm -f $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)/$(PAM_LOGIN_MOD)
	rm -f $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)/$(AUTHKEYS_BIN)
	rm -f $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)/$(OSLOGIN_HELPER)
clean:
	rm -f $(UTILS) $(NSS_LIBRARY_NAME) $(PAM_ADMIN_OBJ) $(PAM_ADMIN_MOD) $(PAM_LOGIN_OBJ) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN)

=== debian/changelog ===
google-compute-image-packages (2.6.0-4) stable; urgency=low

  * Fix DHCP exit hook install.

 -- Google Cloud Team <gc-team@google.com>  Mon, 28 Aug 2017 12:00:00 -0700

google-compute-image-packages (2.6.0-3) stable; urgency=low

  * Add systemd preset.

 -- Google Cloud Team <gc-team@google.com>  Fri, 25 Aug 2017 14:00:00 -0700

google-compute-image-packages (2.6.0-2) stable; urgency=low

  * Add DHCP exit hook script back into package.

 -- Google Cloud Team <gc-team@google.com>  Fri, 25 Aug 2017 12:00:00 -0700

google-compute-image-packages (2.6.0-1) stable; urgency=low

  * New packaging.

 -- Google Cloud Team <gc-team@google.com>  Mon, 27 Jun 2017 12:00:00 -0700

=== debian/control ===
Source: google-compute-image-packages
Section: admin
Priority: optional
Maintainer: Google Cloud Team <gc-team@google.com>
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-systemd (>= 1.5),
               python-all,
               python-setuptools,
               python3-all,
               python3-setuptools,
               python-pytest,
               python3-pytest,
               python-mock,
               python-boto,
               python3-boto
Standards-Version: 3.9.8
Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages

Package: google-compute-engine
Architecture: all
Depends: python:any,
         python3:any,
         ${python:Depends},
         ${python3:Depends},
         ${misc:Depends},
         python-google-compute-engine (= ${source:Version}),
         python3-google-compute-engine (= ${source:Version}),
         ntp,
         systemd
Recommends: google-cloud-sdk
Conflicts: google-compute-engine-jessie,
           google-compute-engine-init-jessie,
           google-config-jessie,
           google-compute-engine-stretch,
           google-compute-engine-init-stretch,
           google-config-stretch,
           google-compute-daemon,
           google-startup-scripts
Replaces: google-compute-engine-jessie,
          google-compute-engine-init-jessie,
          google-config-jessie,
          google-compute-engine-stretch,
          google-compute-engine-init-stretch,
          google-config-stretch,
          google-compute-daemon,
          google-startup-scripts
Description: Google Compute Engine guest environment.
 This package contains scripts, configuration, and systemd init files for features specific to the Google Compute Engine cloud environment.

Package: python-google-compute-engine
Section: python
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}
Conflicts: google-compute-engine-jessie,
           google-compute-engine-stretch,
           google-compute-daemon,
           google-startup-scripts
Description: Google Compute Engine python library for Python 2.x.

Package: python3-google-compute-engine
Section: python
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Conflicts: google-compute-engine-jessie,
           google-compute-engine-stretch,
           google-compute-daemon,
           google-startup-scripts
Description: Google Compute Engine python library for Python 3.x.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/
export PYBUILD_SYSTEM=distutils

%:
	dh $@ --with python2,python3,systemd --buildsystem=pybuild

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-startup-scripts
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-shutdown-scripts

override_dh_python3:
	dh_python3

	# Remove the Python 3 entry scripts.
	rm -rf debian/python3-google-compute-engine/usr/bin

override_dh_python2:
	dh_python2

	# Split the Python 2 entry script to the google-compute-engine package.
	mkdir -p debian/google-compute-engine/usr/bin
	mv debian/python-google-compute-engine/usr/bin/* debian/google-compute-engine/usr/bin/
	rm -rf debian/python-google-compute-engine/usr/bin

override_dh_clean:
	rm -rf google_compute_engine.egg-info
	dh_clean
